#include "m3x3.h"


M3x3::M3x3(V3 r0, V3 r1, V3 r2) {

  rows[0] = r0;
  rows[1] = r1;
  rows[2] = r2;

}

V3 M3x3::operator*(V3 v) {

  V3 ret(rows[0]*v, rows[1]*v, rows[2]*v);
  return ret;

}

V3& M3x3::operator[](int i) {

  return rows[i];

}


void M3x3::SetColumn(int i, V3 c) {

  rows[0][i] = c[0];
  rows[1][i] = c[1];
  rows[2][i] = c[2];

}

V3 M3x3::GetColumn(int i) {

  V3 ret;
  ret[0] = rows[0][i];
  ret[1] = rows[1][i];
  ret[2] = rows[2][i];
  return ret;

}

M3x3 M3x3::operator*(M3x3 m) {

  M3x3 ret;
  ret.SetColumn(0, (*this)*m.GetColumn(0));
  ret.SetColumn(1, (*this)*m.GetColumn(1));
  ret.SetColumn(2, (*this)*m.GetColumn(2));
  return ret;

}
